#ifndef fooparseaddrhfoo
#define fooparseaddrhfoo

/* $Id: parseaddr.h 324 2004-12-15 01:02:50Z lennart $ */

/***
  This file is part of polypaudio.
 
  polypaudio is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2.1 of the
  License, or (at your option) any later version.
 
  polypaudio is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Lesser General Public License for more details.
 
  You should have received a copy of the GNU Lesser General Public
  License along with polypaudio; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
***/

#include <inttypes.h>

enum pa_parsed_address_type {
    PA_PARSED_ADDRESS_UNIX,
    PA_PARSED_ADDRESS_TCP4,
    PA_PARSED_ADDRESS_TCP6,
    PA_PARSED_ADDRESS_TCP_AUTO
};

struct pa_parsed_address {
    enum pa_parsed_address_type type;
    char *path_or_host;
    uint16_t port;
};

int pa_parse_address(const char *a, struct pa_parsed_address *ret_p);

#endif
